package com.management.utils;

import com.alibaba.fastjson.JSONObject;
import com.management.constant.ERPURLConstant;
import com.management.controller.KDTokenController;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;

@Slf4j
public class KingDeeUtils {

    private RestTemplate restTemplate = new RestTemplate();

    /**
     * 根据ERPID和单据类型进行审核
     *
     * @param ErpId
     * @param BillType:
     * @return void
     * @Author weiloong_zhang
     */
    public void audit(String ErpId, String BillType) {
        String url = ERPURLConstant.ERP_URL + "/ierp/kapi/v2/f9w5/devportal/operation/submit";

        //开始封装参数
        Map auditParams = new HashMap();
        auditParams.put("erpId", ErpId);
        auditParams.put("formId", BillType);

        //开始获取accessToken
        //开始获取金蝶token
        String accessToken = new KDTokenController().getKDAccessTokenTest();

        if (accessToken == null || accessToken.equals("")) {
            log.info("金蝶token为空或不存在");
            return;
        }

        //开始封装请求头
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);
        headers.set("accessToken", accessToken);

        HttpEntity auditEntity = new HttpEntity(auditParams, headers);

        JSONObject auditResult = new JSONObject();

        try {
            auditResult = restTemplate.postForObject(url, auditEntity, JSONObject.class);
        } catch (RestClientException e) {
            e.printStackTrace();
        }

        System.out.println("审核单据的状态为：" + auditResult);
    }
}
